#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
/*
 * $Id: Core_end_cycle.cpp 88 2008-12-10 18:31:39Z rosiere $
 *
 * [ Description ]
 * 
 */

#include "Behavioural/Core/include/Core.h"

namespace morpheo {
namespace behavioural {
namespace core {


#undef  FUNCTION
#define FUNCTION "Core::end_cycle"
void Core::end_cycle ()
  {
    log_begin(Core,FUNCTION);

#ifdef STATISTICS
    if (usage_is_set(_usage,USE_STATISTICS))
      _stat->end_cycle();
#endif    

#ifdef VHDL_TESTBENCH
    // Evaluation before read the ouput signal
//  sc_start(0);
    if (usage_is_set(_usage,USE_VHDL_TESTBENCH))
      _interfaces->testbench();
#endif

    log_end(Core,FUNCTION);
  };

}; // end namespace core
}; // end namespace behavioural
}; // end namespace morpheo              
#endif
